pcl::FeatureFromNormals< PointInT, PointNT, PointOutT > Class Template Reference

`#include <pcl/features/feature.h>`

Inheritance diagram for pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >:

## Public Types

typedef pcl::PointCloud< PointNT > | PointCloudN
typedef PointCloudN::Ptr | PointCloudNPtr
typedef PointCloudN::ConstPtr | PointCloudNConstPtr
typedef boost::shared_ptr< FeatureFromNormals< PointInT, PointNT, PointOutT > > | Ptr
typedef boost::shared_ptr< const FeatureFromNormals< PointInT, PointNT, PointOutT > > | ConstPtr
Public Types inherited from pcl::Feature< PointInT, PointOutT >
typedef PCLBase< PointInT > | BaseClass
typedef boost::shared_ptr< Feature< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const Feature< PointInT, PointOutT > > | ConstPtr
typedef pcl::search::Search< PointInT > | KdTree
typedef pcl::search::Search< PointInT >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< PointOutT > | PointCloudOut
typedef boost::function< int(size_t, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, size_t index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| FeatureFromNormals ()
| Empty constructor. More...
virtual | ~FeatureFromNormals ()
| Empty destructor. More...
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input dataset that contains the point normals of the XYZ dataset. More...
PointCloudNConstPtr | getInputNormals () const
| Get a pointer to the normals of the input XYZ point cloud dataset. More...
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

PointCloudNConstPtr | normals_
| A pointer to the input dataset that contains the point normals of the XYZ dataset. More...
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointNT, typename PointOutT>
class pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >

Definition at line 310 of file feature.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT, typename PointNT, typename PointOutT>

typedef boost::shared_ptr< const FeatureFromNormals<PointInT, PointNT, PointOutT> > pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >::ConstPtr

Definition at line 323 of file feature.h.

## PointCloudN

template<typename PointInT, typename PointNT, typename PointOutT>

typedef pcl::PointCloud<PointNT> pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >::PointCloudN

Definition at line 318 of file feature.h.

## PointCloudNConstPtr

template<typename PointInT, typename PointNT, typename PointOutT>

typedef PointCloudN::ConstPtr pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >::PointCloudNConstPtr

Definition at line 320 of file feature.h.

## PointCloudNPtr

template<typename PointInT, typename PointNT, typename PointOutT>

typedef PointCloudN::Ptr pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >::PointCloudNPtr

Definition at line 319 of file feature.h.

## Ptr

template<typename PointInT, typename PointNT, typename PointOutT>

typedef boost::shared_ptr< FeatureFromNormals<PointInT, PointNT, PointOutT> > pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >::Ptr

Definition at line 322 of file feature.h.

## Constructor & Destructor Documentation

## FeatureFromNormals()

template<typename PointInT, typename PointNT, typename PointOutT>

pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >::FeatureFromNormals | ( |  | ) |

inline

Empty constructor.

Definition at line 331 of file feature.h.

## ~FeatureFromNormals()

template<typename PointInT, typename PointNT, typename PointOutT>

virtual pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >::~FeatureFromNormals | ( |  | ) |

inline virtual

Empty destructor.

Definition at line 334 of file feature.h.

## Member Function Documentation

## getInputNormals()

template<typename PointInT, typename PointNT, typename PointOutT>

PointCloudNConstPtr pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >::getInputNormals | ( |  | ) | const

inline

Get a pointer to the normals of the input XYZ point cloud dataset.

Definition at line 348 of file feature.h.

## initCompute()

template<typename PointInT , typename PointNT , typename PointOutT >

bool pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >::initCompute | ( |  | ) |

protected virtual

This method should get called before starting the actual computation.

Reimplemented from pcl::Feature< PointInT, PointOutT >.

Reimplemented in pcl::VFHEstimation< PointInT, PointNT, PointOutT >, pcl::SHOTColorEstimationOMP< PointInT, PointNT, PointOutT, PointRFT >, pcl::ShapeContext3DEstimation< PointInT, PointNT, PointOutT >, pcl::SHOTEstimationBase< PointInT, PointNT, PointOutT, PointRFT >, and pcl::SHOTEstimationOMP< PointInT, PointNT, PointOutT, PointRFT >.

Definition at line 229 of file feature.hpp.

## setInputNormals()

template<typename PointInT, typename PointNT, typename PointOutT>

void pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >::setInputNormals | ( | const PointCloudNConstPtr & | normals | ) |

inline

Provide a pointer to the input dataset that contains the point normals of the XYZ dataset.

In case of search surface is set to be different from the input cloud, normals should correspond to the search surface, not the input cloud!

Parameters

  [in] | normals | the const boost shared pointer to a PointCloud of normals. By convention, L2 norm of each normal should be 1.

Definition at line 344 of file feature.h.

Referenced by pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::UnaryClassifier< PointT >::computeFPFH(), pcl::Hough3DGrouping< PointModelT, PointSceneT, PointModelRfT, PointSceneRfT >::computeRf(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::computeRFAndShapeDistribution(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::estimateFeatures(), and pcl::CVFHEstimation< PointInT, PointNT, PointOutT >::filterNormalsWithHighCurvature().

## Member Data Documentation

## normals_

template<typename PointInT, typename PointNT, typename PointOutT>

PointCloudNConstPtr pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >::normals_

protected

A pointer to the input dataset that contains the point normals of the XYZ dataset.

Definition at line 354 of file feature.h.

Referenced by pcl::CPPFEstimation< PointInT, PointNT, PointOutT >::CPPFEstimation(), pcl::PPFEstimation< PointInT, PointNT, PointOutT >::PPFEstimation(), pcl::PPFRGBEstimation< PointInT, PointNT, PointOutT >::PPFRGBEstimation(), and pcl::PPFRGBRegionEstimation< PointInT, PointNT, PointOutT >::PPFRGBRegionEstimation().

The documentation for this class was generated from the following files:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/features/include/pcl/features/feature.h
- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/features/include/pcl/features/impl/feature.hpp